#include "glut.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
 
/*PI*/
#define M_PI 3.1415

/*CLAVIER*/
int choice=-1;
 
/*L longueur d'un ressort, lm longueur d'une masse*/ 
float L,lm; 
 /*force de la pesanteur des masses 1,2*/ 
float r1,r2; 
/*coefficient de raideur K des ressorts 1,2,3*/ 
float k1,k2,k3; 
/*coefficient d'amortissement C des ressorts 1,2,3*/ 
float c1,c2,c3; 
/*poids des masses 1 et 2*/ 
float m1,m2; 
float distance[2],theta;
/*mouvement a t, t-Dt de la masse 1*/ 
float ut1,utMoinsDt1; 
/*mouvement a t, t-Dt de la masse 2*/ 
float ut2,utMoinsDt2; 
/*vitesse de la masse 1 et de la masse 2*/
float vt1,vt2;
/*acceleration de la masse 1 et de la masse 2*/
float at1,at2;
/*delta t et delta t aux carre*/
float Dt, Dt2;
/*parametre constants pour le calcul des dt + 1 */
float a1,b1,c1,d1,a2,b2,c2,d2;
 
/*dessine un ressort*/
void drawRessort(void)
{
	GLint	spire, spires=8;
	glColor3f(1.0, 0.0, 0.0);
	glBegin(GL_LINE_STRIP);
		glVertex2d(0.0, 0.0);
		glVertex2d(0.0, -0.05);
		for (spire = 0; spire < spires; spire++) 
		{
			glVertex2f( 0.2f, (GLfloat)(-(spire + 0.25) * 0.9 / spires - 0.05));
			glVertex2f(-0.2f, (GLfloat)(-(spire + 0.75) * 0.9 / spires - 0.05));
		}
		glVertex2d(0.0, -0.95);
		glVertex2d(0.0, -1.0);
	glEnd();
} 
 

/*dessine une masse*/
void drawMasse(void)
{
	glColor3f(0.0, 0.0, 1.0);
	glBegin(GL_POLYGON);
		glVertex2d(0.2, -1.0);
		glVertex2d(0.3, -1.4);
		glVertex2d(-0.3, -1.4);
		glVertex2d(-0.2, -1.0);
	glEnd();
}
 
 
/*fonction d'initialisation du systeme*/
void myinit (void)
{
	float aux1,aux2;
	/* Pas de temps*/ 
	Dt=0.01f;            
	Dt2=Dt*Dt; 

	/*pas d'amortissement*/ 
	c1=0;c2=0;c3=0; 
	/*oscillations libres des masses*/ 
	r1=0;r2=0.0; 
 
	/*initialisation des parametre des ressort*/
	ut1=0.0; ut2=0.0; 
 	vt1=0.2; vt2=-0.2; 
 	m1 =2.0; m2 =2.0; 
 	k1 =3.0; k2=3.0; k3 =3.0;
	L=1.0; lm=0.4;

	/*calcul de l'acceleration a t=0*/ 
	at1=(r1-((k1+k2)*ut1-k2*ut2))/m1; 
	at2=(r2-(-k2*ut1+(k2+k3)*ut2))/m2; 
 
	/*calcul de ut a t-dt*/ 
	utMoinsDt1=ut1-Dt*vt1+Dt2/2.0*at1; 
	utMoinsDt2=ut2-Dt*vt2+Dt2/2.0*at2;

	/*calcul des constantes */
	aux1=(Dt2/m1);
	aux2=(Dt2/m2);
	
	a1=r1*aux1;
	b1=-aux1*(k1+k2-(2.0*m1/Dt2));
	c1=aux1*k2;
	d1=-aux1*(m1/Dt2);
	
	a2=r2*aux2;
	b2=k2*aux2;
	c2=-aux2*(k3+k2-(2.0*m2/Dt2));
	d2=-aux2*(m2/Dt2);

	printf("Appuyer sur une touche pour lancer l'animation\n");
}

/* fonction qui permet d'afficher une ligne de trois ressorts et deux masses*/
void aff3ressort(float u1,float u2,float y)
{
	glPushMatrix(); 
		glTranslatef(0.0,y,0.0);	 
		glRotatef((GLfloat)((theta + M_PI/2.)*(180./M_PI)),0.0, 0.0, 1.0); 
		/*dessin masse 1*/ 
		glPushMatrix(); 
			glTranslatef (0.0,-u1,0.0); 
			drawMasse(); 
		glPopMatrix (); 
	 
		/*dessin masse 2*/ 
		glPushMatrix(); 
			glTranslatef (0.0,-(L+lm+u2),0.0); 
			drawMasse(); 
		glPopMatrix (); 
 
		/*dessin ressort 1*/ 
		glPushMatrix(); 
			glTranslatef (0.0,0.0,0.0); 
			glScalef (1.0,(L+u1)/L, 1.0); 
			drawRessort(); 
		glPopMatrix (); 
 
		/*dessin ressort 2*/ 
		glPushMatrix(); 
			glTranslatef (0.0,-(L+lm+u1),0.0); 
			glScalef (1.0,(L+u2-u1)/L,1.0); 
			drawRessort(); 
		glPopMatrix (); 
 
		/*dessin ressort 3*/ 
		glPushMatrix(); 
			glTranslatef (0.0,-2*(L+lm)-u2,0.0); 
			glScalef (1.0,(L-u2)/L, 1.0); 
			drawRessort(); 
		glPopMatrix (); 
 
	glPopMatrix ();
}

/* fonction d'affichage*/
void display(void)
{
	glClearColor (0.0, 0.0, 0.0, 0.0);
	glClear (GL_COLOR_BUFFER_BIT);
 	aff3ressort(ut1, ut2, 0.0);
	glFlush();
	glutSwapBuffers(); 
}

/* Initialisation de fenetre open GL*/
void  myReshape (GLsizei w, GLsizei h)
{ 
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0.0,4.0,-3.0,2.0,-1.0,1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void clavier(unsigned char touche,int x,int y)
{
	choice = atoi(&touche);
}

/* Calcul des valeurs de deplacements par la methode des differences centrales*/
void calcul_ut(void)
{
	if(choice!=-1)
	{
		float ut1PlusDt;
		float ut2PlusDt;
	
		ut1PlusDt=a1+b1*ut1+c1*ut2+d1*utMoinsDt1;
		ut2PlusDt=a2+b2*ut1+c2*ut2+d2*utMoinsDt2;
		utMoinsDt1=ut1;
		utMoinsDt2=ut2;
		ut1=ut1PlusDt;
		ut2=ut2PlusDt;
	}
	display();
}

int main (int argc, char **argv)
{
	myinit();
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA);
    glutInitWindowSize(600,600);
    glutInitWindowPosition(30,30);
    glutCreateWindow(argv[0]);
    glutReshapeFunc(myReshape);
    glutDisplayFunc(display);
	glutKeyboardFunc(clavier);
	glutIdleFunc(calcul_ut);
    glutMainLoop();
    return 0;
}
